/**************************************************************/
/*					  Jewel Crafting System 3
/* 
/*	Scripted by Ravenal/awakenlands
/*  Completed on:  5/31/2005
/*
/*	This script is for anyone to use and edit, please be 
/*  considerate not to claim this as your script, thanks.
/*	
/*	Script Site:	   http://jcs3.uniphix.com
/*	Shard's Site:	   http://www.paragonix.org
/*	Developer's Site:  http://www.orbsydia.com
/*	Emulator's Site:   http://www.runuo.com
/*
/*					  Script Version 3.0b
/**************************************************************/

using System;
using Server;
using Server.Items;
using Server.Mobiles;
using Server.Targeting;
using Server.Engines.Harvest;

namespace Server.Engines.JewelCraft
{
	public class CrystalMining : HarvestSystem
	{
		private static CrystalMining m_System;

		public static CrystalMining System
		{
			get
			{
				if ( m_System == null )
					m_System = new CrystalMining();

				return m_System;
			}
		}

		private CrystalMining()
		{
			HarvestResource[] res = null;
			HarvestVein[] veins = null;		

			JCore.GetGemCrystalMining( this, res, veins );
			JCore.GetGemMining( this, res, veins );
			JCore.GetBarMining( this, res, veins );
		}

		public override bool BeginHarvesting( Mobile from, Item tool )
		{
			if ( !base.BeginHarvesting( from, tool ) )
				return false;

			from.SendLocalizedMessage( 503033 ); // Where do you wish to dig?
			return true;
		}

		public override void SendSuccessTo( Mobile from, Item item, HarvestResource resource )
		{
			if ( item is BaseBars )
				from.SendMessage( "You carefully extract some workable bars from the vein!" );
			else
				base.SendSuccessTo( from, item, resource );
		}

		public override bool CheckHarvest( Mobile from, Item tool )
		{
			if ( !base.CheckHarvest( from, tool ) )
				return false;

			if ( from.Mounted )
			{
				from.SendLocalizedMessage( 501864 ); // You can't mine while riding.
				return false;
			}
			else if ( from.IsBodyMod && !from.Body.IsHuman )
			{
				from.SendLocalizedMessage( 501865 ); // You can't mine while polymorphed.
				return false;
			}

			return true;
		}

		public override void OnBadHarvestTarget( Mobile from, Item tool, object toHarvest )
		{
			if( toHarvest is StaticTarget )
			{
				from.SendLocalizedMessage( 501862 ); // You can't mine there.
			}
			else if( toHarvest is LandTarget )
			{
				from.SendLocalizedMessage( 501862 ); // You can't mine there.
			}
			else
			{
				from.SendMessage( "You can't harvest that." );
			}
		}

		public override void OnHarvestFinished(Mobile from, Item tool, HarvestDefinition def, HarvestVein vein, HarvestBank bank, HarvestResource resource, object harvested)
		{
			HarvestResource res = vein.PrimaryResource;

			if( from.Map == Map.Ilshenar )
			{
				if( res == resource && res.Types[0] == typeof( ParagonBar ) )
				{
					base.OnHarvestFinished (from, tool, def, vein, bank, resource, harvested);
				}
				else if( res == resource && res.Types[0] == typeof( OrbsydianBar ) )
				{
					base.OnHarvestFinished (from, tool, def, vein, bank, resource, harvested);
				}
			}
			else if( from.Map == Map.Malas )
			{
				if( res == resource && res.Types[0] == typeof( ArycilanBar ) )
				{
					base.OnHarvestFinished (from, tool, def, vein, bank, resource, harvested);
				}
				else if( res == resource && res.Types[0] == typeof( XulianBar ) )
				{
					base.OnHarvestFinished (from, tool, def, vein, bank, resource, harvested);
				}
			}
			else
			{
				base.OnHarvestFinished (from, tool, def, vein, bank, resource, harvested);
			}
		}

		public override bool GetHarvestDetails( Mobile from, Item tool, object toHarvest, out int tileID, out Map map, out Point3D loc )
		{
			if ( toHarvest is Static && !((Static)toHarvest).Movable )
			{
				Static obj = (Static)toHarvest;

				tileID = obj.ItemID;
				map = obj.Map;
				loc = obj.GetWorldLocation();
			}
			else if ( toHarvest is StaticTarget )
			{
				StaticTarget obj = (StaticTarget)toHarvest;

				tileID = obj.ItemID;
				map = from.Map;
				loc = obj.Location;
			}
			else
			{
				return base.GetHarvestDetails( from, tool, toHarvest, out tileID, out map, out loc );
			}

			return ( map != null && map != Map.Internal );
		}

	}
}