/**************************************************************/
/*					  Jewel Crafting System 3
/* 
/*	Scripted by Ravenal/awakenlands
/*  Completed on:  5/31/2005
/*
/*	This script is for anyone to use and edit, please be 
/*  considerate not to claim this as your script, thanks.
/*	
/*	Script Site:	   http://jcs3.uniphix.com
/*	Shard's Site:	   http://www.paragonix.org
/*	Developer's Site:  http://www.orbsydia.com
/*	Emulator's Site:   http://www.runuo.com
/*
/*					  Script Version 3.0b
/**************************************************************/

using System;
using Server;
using Server.Engines.Harvest;
using Server.Engines.JewelCraft;
using Server.Targeting;
using Server.Targets;

namespace Server.Items
{
	public class JewelryChisel : BaseHarvestTool
	{
		public override HarvestSystem HarvestSystem{ get{ return CrystalMining.System; } }

		[Constructable]
		public JewelryChisel() : this( 50 )
		{
		}

		[Constructable]
		public JewelryChisel( int uses ) : base( uses, 0x12B3 )
		{
			Name = "jewelry chisel";
			Hue = Server.Engines.JewelCraft.JCore.JewelryChiselHue;
			Weight = 5.0;
		}

		public override void OnDoubleClick(Mobile from)
		{
			from.SendMessage( "Target a jewelry rock to chip!" );

			from.Target = new JewelryTarget( ((BaseHarvestTool)this) );			
		}

		private class JewelryTarget : Target
		{
			private BaseHarvestTool m_Item;

			public JewelryTarget( BaseHarvestTool i ):base( -1, true, TargetFlags.None )
			{ 
				m_Item = i;
			}

			private void GetGem( Mobile from )
			{
				switch( Utility.Random( 12 ) )
				{
					case 0: from.AddToBackpack( new Amber() ); break;
					case 1: from.AddToBackpack( new Amethyst() ); break;
					case 2: from.AddToBackpack( new Emerald() ); break;
					case 3: from.AddToBackpack( new Onyx() ); break;
					case 4: from.AddToBackpack( new Ruby() ); break;
					case 5: from.AddToBackpack( new Sapphire() ); break;
					case 6: from.AddToBackpack( new Citrine() ); break;
					case 7: from.AddToBackpack( new StarSapphire() ); break;
					case 8: from.AddToBackpack( new Tourmaline() ); break;
					case 9: from.AddToBackpack( new Opal() ); break;
					case 10: from.AddToBackpack( new StarRose() ); break;
					case 11: from.AddToBackpack( new Turquoise() ); break;
				}
			}

			protected override void OnTarget(Mobile from, object o)
			{
				if( o is JewelRock && ((JewelRock)o) != null )
				{
					if( ((from.Skills[SkillName.Mining].Value + from.Skills[SkillName.Tinkering].Value) * 0.001 ) >= Utility.RandomDouble() )
					{
						GetGem(from);

						from.SendMessage( "You sucessfully chip the jewelry rock and recieved some sort of gem." );

						((JewelRock)o).Delete();
					}
					else
					{
						from.SendMessage( "You fail to find any gem in this rock." );
						
						((JewelRock)o).Delete();
					}

					if ( m_Item != null )
					{
						IUsesRemaining toolWithUses = (IUsesRemaining)m_Item;

						toolWithUses.ShowUsesRemaining = true;

						if ( toolWithUses.UsesRemaining > 0 )
							--toolWithUses.UsesRemaining;

						if ( toolWithUses.UsesRemaining < 1 )
						{
							m_Item.Delete();
							from.SendLocalizedMessage( 1044038 ); // You have worn out your tool!
						}
					}
				}
				else
				{
					from.SendMessage( "That is not a Jewelry Rock!" );
				}
			}
		}

		public JewelryChisel( Serial serial ) : base( serial )
		{
		}

		public override void Serialize( GenericWriter writer )
		{
			base.Serialize( writer );

			writer.Write( (int) 0 ); // version
		}

		public override void Deserialize( GenericReader reader )
		{
			base.Deserialize( reader );

			int version = reader.ReadInt();
		}
	}
}