/**************************************************************/
/*					  Jewel Crafting System 3
/* 
/*	Scripted by Ravenal/awakenlands
/*  Completed on:  5/31/2005
/*
/*	This script is for anyone to use and edit, please be 
/*  considerate not to claim this as your script, thanks.
/*	
/*	Script Site:	   http://jcs3.uniphix.com
/*	Shard's Site:	   http://www.paragonix.org
/*	Developer's Site:  http://www.orbsydia.com
/*	Emulator's Site:   http://www.runuo.com
/*
/*					  Script Version 3.0d
/**************************************************************/

using System;
using Server;
using Server.Items;
using Server.Engines.Harvest;
using Server.Engines.Craft;

namespace Server.Engines.JewelCraft
{
	/// <summary>
	/// JCore is the main source of your Script Editing, you and edit pretty much everything here
	/// Just take a nice observing of all the codes on this page and edit whatever you wish here.
	/// </summary>
	public class JCore
	{
		/* NOTE: 
		 * Jewel Crafting is only ENABLED if AOS is Enabled
		 * Reasoning is because Jewel Crafting uses all the sources of AOS Properties
		 */
		public static string CraftTitle = "Jewel Crafting"; // This is used in the DefJewelCrafting.cs
		public static SkillName CraftSkill = SkillName.Tinkering; // This is the Crafting Skill used by...
		public static bool Enabled = JCore.AOS; // READ NOTE: {You can set this to be false, but this checks to see if SE and AOS is both Enabled since it uses both systems.}

		public static int JewelryKitHue = 16;
		public static int JewelryShovelHue = 16;
		public static int JewelryRockHue = 1285;
		public static int JewelryChiselHue = 16;
		public static int EnchantedScrollHue = 16;

		private static double ImbuedBonus = 0.25; //Imbued gives 25% Increase in magical properties
		private static double ImbuedEnchantedBonus = 0.45; // Enchanted and Imbued together raises 45% in magical properties
		private static int CraftSound = 42; // Anvil Sound
		public static int ManaReq = 15; // It now takes alittle mana to enchant a item.

		public static bool SellRares = false; // If this is set to true, the rares on the Gems/Bars will be sold, otherwise they will not be sold...
		public static bool SellEnchantedScroll = false; // If this is true, it will sell the Enchanted Scroll for 2500 Gold each
		public static bool SellJewelryChisel = false; // This will be part of the Quest, You can Enable it to be sold to players.
		public static bool SellJewelRock = false; // This is harvestable, but if you want the players to buy them, they are 8gp each.

		public static bool AllowMarker = true; // This is to allow players to have "Who crafted the Item" under the item's name.

		#region GetNames of Jewelry or Bars
		
		/// <summary>
		/// Gets the Names for GemType and BarTypes
		/// </summary>
		/// <param name="item"></param>
		public static void GetNames( Item item )
		{
			if( item != null )
			{	
				if( item is BaseJewel )
				{
					BaseJewel jewel = item as BaseJewel;
					
					string bartype = null;
					string gemtype = null;
					
					switch( jewel.GemType )
					{
						case GemType.None: gemtype = null;	break;
						case GemType.Amber: gemtype = "amber "; break;
						case GemType.Amethyst: gemtype = "amethyst "; break;
						case GemType.Citrine: gemtype = "citrine "; break;
						case GemType.Diamond: gemtype = "diamond "; break;
						case GemType.Emerald: gemtype = "emerald "; break;
						case GemType.Ruby: gemtype = "ruby "; break;
						case GemType.Sapphire: gemtype = "sapphire "; break;
						case GemType.StarSapphire: gemtype = "star sapphire "; break;
						case GemType.Tourmaline: gemtype = "tourmaline "; break;
						
						//New Gems
						case GemType.FireEmerald: gemtype = "fire emerald "; break;
						case GemType.Onyx: gemtype = "onyx "; break;
						case GemType.StarRuby: gemtype = "star ruby "; break;
						case GemType.BlueDiamond: gemtype = "blue diamond "; break;
						case GemType.FireOpal: gemtype = "fire opal "; break;
						case GemType.Jade: gemtype = "jade "; break;
						case GemType.Jasper: gemtype = "jasper "; break;
						case GemType.Pearl: gemtype = "pearl "; break;
						case GemType.Opal: gemtype = "opal "; break;
						case GemType.StarRose: gemtype = "star rose "; break;
						case GemType.Topaz: gemtype = "topaz "; break;
						case GemType.Turquoise: gemtype = "turquoise "; break;
					}
					
					switch( jewel.BarType )
					{
						case BarType.None: bartype = null; break;
						case BarType.Copper: bartype = "copper "; break;
						case BarType.Silver: bartype = "silver "; break;
						case BarType.Gold: bartype = "gold "; break;
						case BarType.Platinum: bartype = "platinum "; break;
						case BarType.Velium: bartype = "velium "; break;
						case BarType.Arycilan: bartype = "Arycilan "; break;
						case BarType.Orbsydian: bartype = "orbsydian "; break;
						case BarType.Xulian: bartype = "xulian "; break;
						case BarType.Paragon: bartype = "paragon "; break;
					}
					
					if( jewel.Amount == 1 )
						jewel.Name = String.Format( "{0}{1}{2}", bartype, gemtype, jewel.OldName );
					else
						jewel.Name = String.Format( "{0}{1}{2}s", bartype, gemtype, jewel.OldName );
				}
			
				if( item is BaseBars )
				{
					BaseBars bar = item as BaseBars;
					string bartype = null;
				
					switch( bar.BarType )
					{
						case BarType.None: bartype = null; break;
						case BarType.Copper: bartype = "copper "; break;
						case BarType.Silver: bartype = "silver "; break;
						case BarType.Gold: bartype = "gold "; break;
						case BarType.Platinum: bartype = "platinum "; break;
						case BarType.Velium: bartype = "velium "; break;
						case BarType.Arycilan: bartype = "Arycilan "; break;
						case BarType.Orbsydian: bartype = "orbsydian "; break;
						case BarType.Xulian: bartype = "xulian "; break;
						case BarType.Paragon: bartype = "paragon "; break;
					}
					
					if( bar.Amount == 1 )
						bar.Name = String.Format( "{0}{1}", bartype, bar.OldName );
					else
						bar.Name = String.Format( "{0}{1}s", bartype, bar.OldName );
				}
			}
		}
		
		/// <summary>
		/// Gets the Core's Names but only gets the attcual name.
		/// </summary>
		/// <param name="item"></param>
		/// <returns></returns>
		public static string GetName( Item item )
		{
			JCore.GetNames( item );
			
			return item.Name;
		}
		
		#endregion
		
		#region Jewelry Bonuses
		/// <summary>
		/// Gets the Enchanted Bonuses, this is used in the BaseJewel.cs
		/// </summary>
		/// <param name="jewel"></param>
		public static void GetEnchantBonus( BaseJewel jewel )
		{
			switch( jewel.GemType )
			{
				case GemType.None: default:
					break;
				case GemType.Amber: 
					jewel.Attributes.BonusStr = jewel.GetStats();
					break;
				case GemType.Amethyst: 
					jewel.Attributes.LowerManaCost = jewel.GetPercent();
					break;
				case GemType.Citrine: 
					jewel.Attributes.LowerRegCost = jewel.GetPercent();
					break;
				case GemType.Emerald: 
					jewel.Attributes.LowerRegCost = jewel.GetStats();
					break;
				case GemType.Diamond: 
					jewel.Resistances.Physical = jewel.GetResistances(-2);
					jewel.Resistances.Cold = jewel.GetResistances();
					jewel.Resistances.Fire = jewel.GetResistances();
					jewel.Resistances.Energy = jewel.GetResistances();
					jewel.Resistances.Poison = jewel.GetResistances();
					break;
				case GemType.Ruby: 
					jewel.Attributes.BonusHits = jewel.GetBonus();
					break;
				case GemType.Sapphire: 
					jewel.Attributes.BonusInt = jewel.GetStats();
					break;
				case GemType.StarSapphire: 
					jewel.Attributes.BonusMana = jewel.GetBonus();
					break;
				case GemType.Tourmaline: 
					jewel.Attributes.BonusStam = jewel.GetBonus();
					break;
				/* Note: Reminder, if you see a /**/ /* before the case, this means
				 * that the resource is hard to obtain, or can be rare also
				 */
				/**/case GemType.StarRuby: 
					jewel.Attributes.Luck = jewel.GetLuck(-10);
					jewel.Attributes.NightSight = 1;
					jewel.Attributes.BonusHits = jewel.GetBonus(-4);
					break;
				case GemType.Onyx: 
					jewel.Attributes.BonusStr = jewel.GetStats(-1);
					jewel.Attributes.BonusDex = jewel.GetStats(-1);
					break;
				/**/case GemType.FireEmerald: 
					jewel.Attributes.Luck = jewel.GetLuck();
					jewel.Attributes.NightSight = 1;
					jewel.Attributes.BonusDex = jewel.GetStats(-2);
					break;
				/**/case GemType.Jade: 
					jewel.Attributes.BonusDex = jewel.GetStats(1);
					jewel.Resistances.Poison = jewel.GetResistances(2);
					jewel.Attributes.BonusStr = jewel.GetStats(-3);
					break;
				/**/case GemType.Jasper: 
					jewel.Attributes.BonusDex = jewel.GetStats(-2);
					jewel.Attributes.BonusInt = jewel.GetStats(2);
					jewel.Attributes.BonusStr = jewel.GetStats(-2);
					break;
				/**/case GemType.FireOpal: 
					jewel.Resistances.Fire = jewel.GetStats(5);
					jewel.Resistances.Cold = jewel.GetStats(-5);
					jewel.Attributes.NightSight = 1;
					break;
				/**/case GemType.Pearl: 
					jewel.Resistances.Energy = jewel.GetStats(5);
					jewel.Resistances.Physical = jewel.GetStats(-7);
					jewel.Attributes.NightSight = 1;
					jewel.Attributes.Luck = jewel.GetLuck();
					break;
				case GemType.Opal: 
					jewel.Resistances.Fire = jewel.GetStats(5);
					jewel.Resistances.Cold = jewel.GetStats(-7);
					break;
				/**/case GemType.Topaz: 
					jewel.Resistances.Fire = jewel.GetStats(3);
					jewel.Resistances.Cold = jewel.GetStats(-1);
					jewel.Resistances.Energy = jewel.GetStats(-1);
					jewel.Attributes.NightSight = 1;
					break;
				case GemType.Turquoise: 
					jewel.Resistances.Cold = jewel.GetStats(-1);
					jewel.Attributes.BonusMana = jewel.GetBonus(-3);
					break;
				case GemType.StarRose: 
					jewel.Resistances.Energy = jewel.GetStats();
					jewel.Attributes.Luck = jewel.GetLuck(-10);
					break;
				/**/case GemType.BlueDiamond: 
					jewel.Resistances.Physical = jewel.GetResistances(-2);
					jewel.Resistances.Cold = jewel.GetResistances();
					jewel.Resistances.Fire = jewel.GetResistances();
					jewel.Resistances.Energy = jewel.GetResistances();
					jewel.Resistances.Poison = jewel.GetResistances();
					jewel.Attributes.BonusMana = jewel.GetBonus(-4);
					jewel.Attributes.NightSight = 1;
					break;
			}
		}
		
		/// <summary>
		/// Gets the Imbued Bonuses for the Jewelry, used in BaseJewel.cs
		/// </summary>
		/// <param name="jewel"></param>
		public static void GetImbuedBonus( BaseJewel jewel )
		{
			switch( jewel.GemType )
			{
				case GemType.None: default:
					break;
				case GemType.Amber: 
					jewel.Attributes.BonusStr = JCore.ImbuedEquation(jewel,jewel.GetStats());
					break;
				case GemType.Amethyst: 
					jewel.Attributes.LowerManaCost = JCore.ImbuedEquation(jewel,jewel.GetPercent());
					break;
				case GemType.Citrine: 
					jewel.Attributes.LowerRegCost = JCore.ImbuedEquation(jewel,jewel.GetPercent());
					break;
				case GemType.Emerald: 
					jewel.Attributes.LowerRegCost = JCore.ImbuedEquation(jewel,jewel.GetStats());
					break;
				case GemType.Diamond: 
					jewel.Resistances.Physical = JCore.ImbuedEquation(jewel,jewel.GetResistances(-2));
					jewel.Resistances.Cold = JCore.ImbuedEquation(jewel,jewel.GetResistances());
					jewel.Resistances.Fire = JCore.ImbuedEquation(jewel,jewel.GetResistances());
					jewel.Resistances.Energy = JCore.ImbuedEquation(jewel,jewel.GetResistances());
					jewel.Resistances.Poison = JCore.ImbuedEquation(jewel,jewel.GetResistances());
					break;
				case GemType.Ruby: 
					jewel.Attributes.BonusHits = JCore.ImbuedEquation(jewel,jewel.GetBonus());
					break;
				case GemType.Sapphire: 
					jewel.Attributes.BonusInt = JCore.ImbuedEquation(jewel,jewel.GetStats());
					break;
				case GemType.StarSapphire: 
					jewel.Attributes.BonusMana = JCore.ImbuedEquation(jewel,jewel.GetBonus());
					break;
				case GemType.Tourmaline: 
					jewel.Attributes.BonusStam = JCore.ImbuedEquation(jewel,jewel.GetBonus());
					break;
				/* Note: Reminder, if you see a /**/ /* before the case, this means
				 * that the resource is hard to obtain, or can be rare also
				 */
				/**/case GemType.StarRuby: 
				 	jewel.Attributes.Luck = JCore.ImbuedEquation(jewel,jewel.GetLuck(-10));
					jewel.Attributes.NightSight = 1;
					jewel.Attributes.BonusHits = JCore.ImbuedEquation(jewel,jewel.GetBonus(-4));
					break;
				case GemType.Onyx: 
					jewel.Attributes.BonusStr = JCore.ImbuedEquation(jewel,jewel.GetStats(-1));
					jewel.Attributes.BonusDex = JCore.ImbuedEquation(jewel,jewel.GetStats(-1));
					break;
				/**/case GemType.FireEmerald: 
					jewel.Attributes.Luck = JCore.ImbuedEquation(jewel,jewel.GetLuck());
					jewel.Attributes.NightSight = 1;
					jewel.Attributes.BonusDex = JCore.ImbuedEquation(jewel,jewel.GetStats(-2));
					break;
				/**/case GemType.Jade: 
					jewel.Attributes.BonusDex = JCore.ImbuedEquation(jewel,jewel.GetStats(1));
					jewel.Resistances.Poison = JCore.ImbuedEquation(jewel,jewel.GetResistances(2));
					jewel.Attributes.BonusStr = JCore.ImbuedEquation(jewel,jewel.GetStats(-3));
					break;
				/**/case GemType.Jasper: 
					jewel.Attributes.BonusDex = JCore.ImbuedEquation(jewel,jewel.GetStats(-2));
					jewel.Attributes.BonusInt = JCore.ImbuedEquation(jewel,jewel.GetStats(2));
					jewel.Attributes.BonusStr = JCore.ImbuedEquation(jewel,jewel.GetStats(-2));
					break;
				/**/case GemType.FireOpal: 
					jewel.Resistances.Fire = JCore.ImbuedEquation(jewel,jewel.GetStats(5));
					jewel.Resistances.Cold = JCore.ImbuedEquation(jewel,jewel.GetStats(-5));
					jewel.Attributes.NightSight = 1;
					break;
				/**/case GemType.Pearl: 
					jewel.Resistances.Energy = JCore.ImbuedEquation(jewel,jewel.GetStats(5));
					jewel.Resistances.Physical = JCore.ImbuedEquation(jewel,jewel.GetStats(-7));
					jewel.Attributes.NightSight = 1;
					jewel.Attributes.Luck = JCore.ImbuedEquation(jewel,jewel.GetLuck());
					break;
				case GemType.Opal: 
					jewel.Resistances.Fire = JCore.ImbuedEquation(jewel,jewel.GetStats(5));
					jewel.Resistances.Cold = JCore.ImbuedEquation(jewel,jewel.GetStats(-7));
					break;
				/**/case GemType.Topaz: 
					jewel.Resistances.Fire = JCore.ImbuedEquation(jewel,jewel.GetStats(3));
					jewel.Resistances.Cold = JCore.ImbuedEquation(jewel,jewel.GetStats(-1));
					jewel.Resistances.Energy = JCore.ImbuedEquation(jewel,jewel.GetStats(-1));
					jewel.Attributes.NightSight = 1;
					break;
				case GemType.Turquoise: 
					jewel.Resistances.Cold = JCore.ImbuedEquation(jewel,jewel.GetStats(-1));
					jewel.Attributes.BonusMana = JCore.ImbuedEquation(jewel,jewel.GetBonus(-3));
					break;
				case GemType.StarRose: 
					jewel.Resistances.Energy = JCore.ImbuedEquation(jewel,jewel.GetStats());
					jewel.Attributes.Luck = JCore.ImbuedEquation(jewel,jewel.GetLuck(-10));
					break;
				/**/case GemType.BlueDiamond: 
					jewel.Resistances.Physical = JCore.ImbuedEquation(jewel,jewel.GetResistances(-2));
					jewel.Resistances.Cold = JCore.ImbuedEquation(jewel,jewel.GetResistances());
					jewel.Resistances.Fire = JCore.ImbuedEquation(jewel,jewel.GetResistances());
					jewel.Resistances.Energy = JCore.ImbuedEquation(jewel,jewel.GetResistances());
					jewel.Resistances.Poison = JCore.ImbuedEquation(jewel,jewel.GetResistances());
					jewel.Attributes.BonusMana = JCore.ImbuedEquation(jewel,jewel.GetBonus(-4));
					jewel.Attributes.NightSight = 1;
					break;
			}
		}
		
		/// <summary>
		/// Gets the Enchanted and Imbued Bonuses, uses the ImbuedEquation and also used in BaseJewel.cs
		/// </summary>
		/// <param name="jewel"></param>
		public static void GetEnchantImbuedBonus( BaseJewel jewel )
		{
			switch( jewel.GemType )
			{
				case GemType.None: default:
					break;
				case GemType.Amber: 
					jewel.Attributes.BonusStr = JCore.ImbuedEquation(jewel,jewel.GetStats());
					break;
				case GemType.Amethyst: 
					jewel.Attributes.LowerManaCost = JCore.ImbuedEquation(jewel,jewel.GetPercent());
					break;
				case GemType.Citrine: 
					jewel.Attributes.LowerRegCost = JCore.ImbuedEquation(jewel,jewel.GetPercent());
					break;
				case GemType.Emerald: 
					jewel.Attributes.LowerRegCost = JCore.ImbuedEquation(jewel,jewel.GetStats());
					break;
				case GemType.Diamond: 
					jewel.Resistances.Physical = JCore.ImbuedEquation(jewel,jewel.GetResistances(-2));
					jewel.Resistances.Cold = JCore.ImbuedEquation(jewel,jewel.GetResistances());
					jewel.Resistances.Fire = JCore.ImbuedEquation(jewel,jewel.GetResistances());
					jewel.Resistances.Energy = JCore.ImbuedEquation(jewel,jewel.GetResistances());
					jewel.Resistances.Poison = JCore.ImbuedEquation(jewel,jewel.GetResistances());
					break;
				case GemType.Ruby: 
					jewel.Attributes.BonusHits = JCore.ImbuedEquation(jewel,jewel.GetBonus());
					break;
				case GemType.Sapphire: 
					jewel.Attributes.BonusInt = JCore.ImbuedEquation(jewel,jewel.GetStats());
					break;
				case GemType.StarSapphire: 
					jewel.Attributes.BonusMana = JCore.ImbuedEquation(jewel,jewel.GetBonus());
					break;
				case GemType.Tourmaline: 
					jewel.Attributes.BonusStam = JCore.ImbuedEquation(jewel,jewel.GetBonus());
					break;
				/* Note: Reminder, if you see a /**/ /* before the case, this means
				 * that the resource is hard to obtain, or can be rare also
				 */
				/**/case GemType.StarRuby: 
				 	jewel.Attributes.Luck = JCore.ImbuedEquation(jewel,jewel.GetLuck(-10));
					jewel.Attributes.NightSight = 1;
					jewel.Attributes.BonusHits = JCore.ImbuedEquation(jewel,jewel.GetBonus(-4));
					break;
				case GemType.Onyx: 
					jewel.Attributes.BonusStr = JCore.ImbuedEquation(jewel,jewel.GetStats(-1));
					jewel.Attributes.BonusDex = JCore.ImbuedEquation(jewel,jewel.GetStats(-1));
					break;
				/**/case GemType.FireEmerald: 
					jewel.Attributes.Luck = JCore.ImbuedEquation(jewel,jewel.GetLuck());
					jewel.Attributes.NightSight = 1;
					jewel.Attributes.BonusDex = JCore.ImbuedEquation(jewel,jewel.GetStats(-2));
					break;
				/**/case GemType.Jade: 
					jewel.Attributes.BonusDex = JCore.ImbuedEquation(jewel,jewel.GetStats(1));
					jewel.Resistances.Poison = JCore.ImbuedEquation(jewel,jewel.GetResistances(2));
					jewel.Attributes.BonusStr = JCore.ImbuedEquation(jewel,jewel.GetStats(-3));
					break;
				/**/case GemType.Jasper: 
					jewel.Attributes.BonusDex = JCore.ImbuedEquation(jewel,jewel.GetStats(-2));
					jewel.Attributes.BonusInt = JCore.ImbuedEquation(jewel,jewel.GetStats(2));
					jewel.Attributes.BonusStr = JCore.ImbuedEquation(jewel,jewel.GetStats(-2));
					break;
				/**/case GemType.FireOpal: 
					jewel.Resistances.Fire = JCore.ImbuedEquation(jewel,jewel.GetStats(5));
					jewel.Resistances.Cold = JCore.ImbuedEquation(jewel,jewel.GetStats(-5));
					jewel.Attributes.NightSight = 1;
					break;
				/**/case GemType.Pearl: 
					jewel.Resistances.Energy = JCore.ImbuedEquation(jewel,jewel.GetStats(5));
					jewel.Resistances.Physical = JCore.ImbuedEquation(jewel,jewel.GetStats(-7));
					jewel.Attributes.NightSight = 1;
					jewel.Attributes.Luck = JCore.ImbuedEquation(jewel,jewel.GetLuck());
					break;
				case GemType.Opal: 
					jewel.Resistances.Fire = JCore.ImbuedEquation(jewel,jewel.GetStats(5));
					jewel.Resistances.Cold = JCore.ImbuedEquation(jewel,jewel.GetStats(-7));
					break;
				/**/case GemType.Topaz: 
					jewel.Resistances.Fire = JCore.ImbuedEquation(jewel,jewel.GetStats(3));
					jewel.Resistances.Cold = JCore.ImbuedEquation(jewel,jewel.GetStats(-1));
					jewel.Resistances.Energy = JCore.ImbuedEquation(jewel,jewel.GetStats(-1));
					jewel.Attributes.NightSight = 1;
					break;
				case GemType.Turquoise: 
					jewel.Resistances.Cold = JCore.ImbuedEquation(jewel,jewel.GetStats(-1));
					jewel.Attributes.BonusMana = JCore.ImbuedEquation(jewel,jewel.GetBonus(-3));
					break;
				case GemType.StarRose: 
					jewel.Resistances.Energy = JCore.ImbuedEquation(jewel,jewel.GetStats());
					jewel.Attributes.Luck = JCore.ImbuedEquation(jewel,jewel.GetLuck(-10));
					break;
				/**/case GemType.BlueDiamond: 
					jewel.Resistances.Physical = JCore.ImbuedEquation(jewel,jewel.GetResistances(-2));
					jewel.Resistances.Cold = JCore.ImbuedEquation(jewel,jewel.GetResistances());
					jewel.Resistances.Fire = JCore.ImbuedEquation(jewel,jewel.GetResistances());
					jewel.Resistances.Energy = JCore.ImbuedEquation(jewel,jewel.GetResistances());
					jewel.Resistances.Poison = JCore.ImbuedEquation(jewel,jewel.GetResistances());
					jewel.Attributes.BonusMana = JCore.ImbuedEquation(jewel,jewel.GetBonus(-4));
					jewel.Attributes.NightSight = 1;
					break;
			}
		}
		#endregion
		
		#region Imbued Equation
		/// <summary>
		/// Example: 25% ( 11*0.25 = 2.75 ) Final: (int)2.75+11 = 14
		/// Example of Both Enchanted and Imbued: 45% ( 11*0.45 = 4.95 ) Final: (int)4.95+11 = 16
		/// </summary>
		/// <param name="jewel">from the BaseJewel.cs</param>
		/// <param name="bonus">Gets the Bonus amount for a certain Jewelry</param>
		/// <returns>bonus+fb</returns>
		public static int ImbuedEquation( BaseJewel jewel, int bonus )
		{	
			int fb = 0;
			// If Imbued and Enchanted, get the Imbued and Enchanted Bonus
			// If NOT then just get Imbued
			if( jewel.Imbued && jewel.Enchanted )
				fb = Convert.ToInt32(bonus*JCore.ImbuedEnchantedBonus);
			else
				fb = Convert.ToInt32(bonus*JCore.ImbuedBonus);
			
			return bonus+fb;
		}
		#endregion
		
		#region Bars ItemID
		
		/// <summary>
		/// The BaseBar ItemIDs are placed here, used in BaseBar.cs
		/// </summary>
		public static int CopperBarID = 0x1be3;
		public static int SilverBarID = 0x1bf5;
		public static int GoldBarID = 0x1be9;
		public static int PlatinumBarID = 0x1bf5;
		public static int VeliumBarID = 0x1bf5;
		public static int ArycilanBarID = 0x1bf5;
		public static int OrbsydianBarID = 0x1bf5;
		public static int XulianBarID = 0x1bf5;
		public static int ParagonBarID = 0x1bf5;
		
		#endregion
		
		#region Gem and Bar Hues
		
		/// <summary>
		/// This is the Bars, and Gem and Jewelry type Hues
		/// These use OSI Hues not Custom Hues, this allows editing easily done.
		/// </summary>
		// Bars
		public static int CopperBarHue = 0;
		public static int SilverBarHue = 0;
		public static int GoldBarHue = 0;
		public static int PlatinumBarHue = 1150;
		public static int VeliumBarHue = 1153;
		public static int ArycilanBarHue = 1282;
		public static int OrbsydianBarHue = 1265;
		public static int XulianBarHue = 1172;
		public static int ParagonBarHue = 1170;
		
		// Gems and Jewelry
		public static int CopperHue = 2413;
		public static int SilverHue = 901;
		public static int GoldHue = 0;
		public static int PlatinumHue = 1150;
		public static int VeliumHue = 1153;
		public static int ArycilanHue = 1282;
		public static int OrbsydianHue = 1265;
		public static int XulianHue = 1172;
		public static int ParagonHue = 1170;
		
		public static int AmberHue = 1259;
		public static int AmethystHue = 15;
		public static int CitrineHue = 44;
		public static int DiamondHue = 1154;
		public static int EmeraldHue = 68;
		public static int RubyHue = 38;
		public static int SapphireHue = 6;
		public static int StarSapphireHue = 3;
		public static int TourmalineHue = 56;
		
		//New Gems
		public static int FireEmeraldHue = 1171;
		public static int OnyxHue = 1109;
		public static int StarRubyHue = 2117;
		public static int JadeHue = 1167;
		public static int JasperHue = 1281;
		public static int FireOpalHue = 1260;
		public static int PearlHue = 2307;
		public static int OpalHue = 2117;
		public static int TopazHue = 1366;
		public static int TurquoiseHue = 1151;
		public static int StarRoseHue = 1166;
		public static int BlueDiamondHue = 1165;
		
		/// <summary>
		/// This Sets the Hue and ItemID for the BaseBar
		/// </summary>
		/// <param name="bar"></param>
		public static void SetHueAndItemID( BaseBars bar )
		{
			switch( bar.BarType )
			{
				case BarType.Copper: 
					bar.ItemID = JCore.CopperBarID;
					bar.Hue = JCore.CopperBarHue; 
					break;
				case BarType.Silver: 
					bar.ItemID = JCore.SilverBarID;
					bar.Hue = JCore.SilverBarHue; 
					break;
				case BarType.Gold: 
					bar.ItemID = JCore.GoldBarID;
					bar.Hue = JCore.GoldBarHue; 
					break;
				case BarType.Platinum:
					bar.ItemID = JCore.PlatinumBarID;
					bar.Hue = JCore.PlatinumBarHue; 
					break;
				case BarType.Velium: 
					bar.ItemID = JCore.VeliumBarID;
					bar.Hue = JCore.VeliumBarHue; 
					break;
				case BarType.Arycilan: 
					bar.ItemID = JCore.ArycilanBarID;
					bar.Hue = JCore.ArycilanBarHue; 
					break;
				case BarType.Orbsydian: 
					bar.ItemID = JCore.OrbsydianBarID;
					bar.Hue = JCore.OrbsydianBarHue; 
					break;
				case BarType.Xulian: 
					bar.ItemID = JCore.XulianBarID;
					bar.Hue = JCore.XulianBarHue; 
					break;
				case BarType.Paragon: 
					bar.ItemID = JCore.ParagonBarID;
					bar.Hue = JCore.ParagonBarHue; 
					break;
			}
		}
		
		/// <summary>
		/// This sets the Hue for all Jewelry in BaseJewels.cs
		/// </summary>
		/// <param name="jewel"></param>
		public static void SetHue( BaseJewel jewel )
		{
			switch( jewel.GemType )
			{
				case GemType.None: jewel.Hue = 0;	break;
				case GemType.Amber: jewel.Hue = JCore.AmberHue; break;
				case GemType.Amethyst: jewel.Hue = JCore.AmethystHue; break;
				case GemType.Citrine: jewel.Hue = JCore.CitrineHue; break;
				case GemType.Diamond: jewel.Hue = JCore.DiamondHue; break;
				case GemType.Emerald: jewel.Hue = JCore.EmeraldHue; break;
				case GemType.Ruby: jewel.Hue = JCore.RubyHue; break;
				case GemType.Sapphire: jewel.Hue = JCore.SapphireHue; break;
				case GemType.StarSapphire: jewel.Hue = JCore.StarSapphireHue; break;
				case GemType.Tourmaline: jewel.Hue = JCore.TourmalineHue; break;
				
				//New Gems
				case GemType.FireEmerald: jewel.Hue = JCore.FireEmeraldHue; break;
				case GemType.Onyx: jewel.Hue = JCore.OnyxHue; break;
				case GemType.StarRuby: jewel.Hue = JCore.StarRubyHue; break;
				case GemType.BlueDiamond: jewel.Hue = JCore.BlueDiamondHue; break;
				case GemType.FireOpal: jewel.Hue = JCore.FireOpalHue; break;
				case GemType.Jade: jewel.Hue = JCore.JadeHue; break;
				case GemType.Jasper: jewel.Hue = JCore.JasperHue; break;
				case GemType.Pearl: jewel.Hue = JCore.PearlHue; break;
				case GemType.Opal: jewel.Hue = JCore.OpalHue; break;
				case GemType.StarRose: jewel.Hue = JCore.StarRoseHue; break;
				case GemType.Topaz: jewel.Hue = JCore.TopazHue; break;
				case GemType.Turquoise: jewel.Hue = JCore.TurquoiseHue; break;
			}
			
			if( jewel.GemType == GemType.None )
			{
				switch( jewel.BarType )
				{
					case BarType.Copper: jewel.Hue = JCore.CopperHue; break;
					case BarType.Silver: jewel.Hue = JCore.SilverHue; break;
					case BarType.Gold: jewel.Hue = JCore.GoldHue; break;
					case BarType.Platinum: jewel.Hue = JCore.PlatinumHue; break;
					case BarType.Velium: jewel.Hue = JCore.VeliumHue; break;
					case BarType.Arycilan: jewel.Hue = JCore.ArycilanHue; break;
					case BarType.Orbsydian: jewel.Hue = JCore.OrbsydianHue; break;
					case BarType.Xulian: jewel.Hue = JCore.XulianHue; break;
					case BarType.Paragon: jewel.Hue = JCore.ParagonHue; break;
				}
			}			
		}
		
		#endregion
		
		#region Magic Properties
		
		/// <summary>
		/// These are the Enchanted Properties on what
		/// they give for each Bonus on Bar Types.
		/// </summary>
		// IF Enchanted
		public static int CopperLuck = 15; // 15 Luck added
		public static int CopperResistance = 1; // 1% Resistance
		public static int CopperPercent = 1; // Gives 1% on any Percent Bonus
		public static int CopperStats = -1; // Gives -1 Bonus in one of the stats or more
		public static int CopperBonus = 5; // Gives 5+ Bonus in one for the HP/Mana/Stamina
		
		public static int SilverLuck = 17; // 17 Luck added
		public static int SilverResistance = 2; // 2% Resistance
		public static int SilverPercent = 4; // Gives 4% on any Percent Bonus
		public static int SilverStats = 1; // Gives 1+ Bonus in one of the stats or more
		public static int SilverBonus = 6; // Gives 6+ Bonus in one for the HP/Mana/Stamina
		
		public static int GoldLuck = 20; // 20 Luck added
		public static int GoldResistance = 4; // 1% Resistance
		public static int GoldPercent = 7; // Gives 7% on any Percent Bonus
		public static int GoldStats = 2; // Gives 2+ Bonus in one of the stats or more
		public static int GoldBonus = 7; // Gives 7+ Bonus in one for the HP/Mana/Stamina
		
		public static int PlatinumLuck = 25; // 25 Luck added
		public static int PlatinumResistance = 5; // 8% Resistance
		public static int PlatinumPercent = 9; // Gives 25% on any Percent Bonus
		public static int PlatinumStats = 3; // Gives 6+ Bonus in one of the stats or more
		public static int PlatinumBonus = 8; // Gives 12+ Bonus in one for the HP/Mana/Stamina
		
		public static int VeliumLuck = 30; // 30 Luck added
		public static int VeliumResistance = 6; // 6% Resistance
		public static int VeliumPercent = 11; // Gives 11% on any Percent Bonus
		public static int VeliumStats = 4; // Gives 4+ Bonus in one of the stats or more
		public static int VeliumBonus = 10; // Gives 10+ Bonus in one for the HP/Mana/Stamina
		
		public static int ArycilanLuck = 35; // 30 Luck added
		public static int ArycilanResistance = 7; // 6% Resistance
		public static int ArycilanPercent = 13; // Gives 11% on any Percent Bonus
		public static int ArycilanStats = 5; // Gives 4+ Bonus in one of the stats or more
		public static int ArycilanBonus = 13; // Gives 10+ Bonus in one for the HP/Mana/Stamina
		
		public static int OrbsydianLuck = 40; // 30 Luck added
		public static int OrbsydianResistance = 8; // 6% Resistance
		public static int OrbsydianPercent = 15; // Gives 11% on any Percent Bonus
		public static int OrbsydianStats = 6; // Gives 4+ Bonus in one of the stats or more
		public static int OrbsydianBonus = 14; // Gives 10+ Bonus in one for the HP/Mana/Stamina
		
		public static int XulianLuck = 45; // 30 Luck added
		public static int XulianResistance = 9; // 6% Resistance
		public static int XulianPercent = 17; // Gives 11% on any Percent Bonus
		public static int XulianStats = 7; // Gives 4+ Bonus in one of the stats or more
		public static int XulianBonus = 16; // Gives 10+ Bonus in one for the HP/Mana/Stamina
		
		public static int ParagonLuck = 50; // 30 Luck added
		public static int ParagonResistance = 11; // 6% Resistance
		public static int ParagonPercent = 18; // Gives 11% on any Percent Bonus
		public static int ParagonStats = 8; // Gives 4+ Bonus in one of the stats or more
		public static int ParagonBonus = 17; // Gives 10+ Bonus in one for the HP/Mana/Stamina
		
		#endregion
		
		/// <summary>
		/// Plays the Craft Sound it is set on above.
		/// </summary>
		/// <param name="m">The Mobile</param>
		public static void PlayCraftSound( Mobile m )
		{
			m.PlaySound( JCore.CraftSound );
		}
		
		/// <summary>
		/// This is BEFORE the item has been crafted.
		/// </summary>
		/// <param name="m">The Mobile</param>
		public static void OnBeforeCraft( Mobile m )
		{
		}
		
		/// <summary>
		/// This is AFTER the item has been crafted.
		/// </summary>
		/// <param name="m">The Mobile</param>
		public static void OnAfterCraft( Mobile m )
		{
		}

		/// <summary>
		/// This gets the Min Skill by the GemType
		/// </summary>
		/// <param name="type">The GemType of BaseJewel.cs</param>
		/// <returns>default: returns 0.0 Skill on <CraftSkill>JCore.CraftSkill</CraftSkill></returns>
		public static double GetGemMinSkill( GemType type )
		{
			switch( type )
			{
				case GemType.None: default: return 0.0;
				case GemType.Amber: return 5.0;
				case GemType.Emerald: return 10.0;
				case GemType.Citrine: return 15.0;
				case GemType.Sapphire: return 20.0;
				case GemType.Tourmaline: return 25.0;
				case GemType.StarSapphire: return 30.0;
				case GemType.Turquoise: return 35.0;
				case GemType.StarRose: return 40.0;
				case GemType.Ruby: return 45.0;
				case GemType.Amethyst: return 55.0;
				case GemType.Onyx: return 60.0;
				case GemType.Topaz: return 65.0;
				case GemType.Opal: return 70.0;
				case GemType.Pearl: return 72.0;
				case GemType.Jade: return 75.0;
				case GemType.Jasper: return 76.0;
				case GemType.FireEmerald: return 77.0;
				case GemType.FireOpal: return 78.0;
				case GemType.StarRuby: return 80.0;
				case GemType.Diamond: return 83.0;
				case GemType.BlueDiamond: return 85.0;
			}
		}

		/// <summary>
		/// Gets the Max Skill of a Gem from BaseJewel.cs
		/// </summary>
		/// <param name="type">GemType from BaseJewel.cs</param>
		/// <returns>default: returns 25.0 Skill in <CraftSkill>JCore.CraftSkill</CraftSkill></returns>
		public static double GetGemMaxSkill( GemType type )
		{
			switch( type )
			{
				case GemType.None: default: return 25.0;
				case GemType.Amber: return 30.0;
				case GemType.Emerald: return 35.0;
				case GemType.Citrine: return 40.0;
				case GemType.Sapphire: return 45.0;
				case GemType.Tourmaline: return 50.0;
				case GemType.StarSapphire: return 55.0;
				case GemType.Turquoise: return 60.0;
				case GemType.StarRose: return 65.0;
				case GemType.Ruby: return 70.0;
				case GemType.Amethyst: return 75.0;
				case GemType.Onyx: return 80.0;
				case GemType.Topaz: return 85.0;
				case GemType.Opal: return 90.0;
				case GemType.Pearl: return 95.0;
				case GemType.Jade: return 100.0;
				case GemType.Jasper: return 105.0;
				case GemType.FireEmerald: return 107.0;
				case GemType.FireOpal: return 110.0;
				case GemType.StarRuby: return 115.0;
				case GemType.Diamond: return 120.0;
				case GemType.BlueDiamond: return 125.0;
			}
		}

		/// <summary>
		/// Gets the Gem Crystal Mining for the CrystalMining.cs
		/// </summary>
		/// <param name="sys"></param>
		/// <param name="res"></param>
		/// <param name="veins"></param>
		public static void GetGemCrystalMining( HarvestSystem sys, HarvestResource[] res, HarvestVein[] veins )
		{
			#region Crystal Mining for Gems
			HarvestDefinition gems = m_MiningGems = new HarvestDefinition();

			// Resource banks are every 8x8 tiles
			gems.BankWidth = 8;
			gems.BankHeight = 8;

			// Every bank holds from 10 to 34 ore
			gems.MinTotal = 10;
			gems.MaxTotal = 34;

			// A resource bank will respawn its content every 10 to 20 minutes
			gems.MinRespawn = TimeSpan.FromMinutes( 10.0 );
			gems.MaxRespawn = TimeSpan.FromMinutes( 20.0 );

			// Skill checking is done on the Mining skill
			gems.Skill = SkillName.Mining;

			// Set the list of harvestable tiles
			gems.Tiles = m_CrystalTiles;

			// Players must be within 2 tiles to harvest
			gems.MaxRange = 2;

			// One ore per harvest action
			gems.ConsumedPerHarvest = 1;
			gems.ConsumedPerFeluccaHarvest = 2;

			// The digging effect
			gems.EffectActions = new int[]{ 11 };
			gems.EffectSounds = new int[]{ 0x125, 0x126 };
			gems.EffectCounts = new int[]{ 1 };
			gems.EffectDelay = TimeSpan.FromSeconds( 1.6 );
			gems.EffectSoundDelay = TimeSpan.FromSeconds( 0.9 );

			gems.NoResourcesMessage = "There is no gems here to mine.";
			gems.DoubleHarvestMessage = "Someone has gotten to the gems before you."; 
			gems.TimedOutOfRangeMessage = 503041; // You have moved too far away to continue mining.
			gems.OutOfRangeMessage = 500446; // That is too far away.
			gems.FailMessage = "You loosen some rocks but fail to find any useable gems.";
			gems.PackFullMessage = "Your backpack is full, so the gem you mined is lost.";
			gems.ToolBrokeMessage = 1044038; // You have worn out your tool!

			res = new HarvestResource[]
				{
					new HarvestResource(  0.0,  0.0, 100.0, "You chip some sort of jewelry rock and put it in your backpack.", typeof( JewelRock ) ),
					new HarvestResource( 20.0,  0.0,  50.0, "You chip some amber, and put it into your backpack.", typeof( Amber ) ),
					new HarvestResource( 25.0,  5.0,  55.0, "You chip some emerald, and put it into your backpack.", typeof( Emerald ) ),
					new HarvestResource( 30.0, 10.0,  60.0, "You chip some star rose, and put it into your backpack.", typeof( StarRose ) ),
					new HarvestResource( 35.0, 15.0,  65.0, "You chip some amethyst, and put it into your backpack.", typeof( Amethyst ) ),
					new HarvestResource( 40.0, 20.0,  70.0, "You chip some citrine, and put it into your backpack.", typeof( Citrine ) ),
					new HarvestResource( 45.0, 25.0,  75.0, "You chip some turquoise, and put it into your backpack.", typeof( Turquoise ) ),
					new HarvestResource( 50.0, 30.0,  80.0, "You chip some ruby, and put it into your backpack.", typeof( Ruby ) ),
					new HarvestResource( 55.0, 35.0,  85.0, "You chip some sapphire, and put it into your backpack.", typeof( Sapphire ) ),
					new HarvestResource( 60.0, 40.0,  90.0, "You chip some tourmaline, and put it into your backpack.", typeof( Tourmaline ) ),	
					new HarvestResource( 65.0, 45.0,  95.0, "You chip some star sapphire, and put it into your backpack.", typeof( StarSapphire ) ),	
					new HarvestResource( 70.0, 50.0, 105.0, "You chip some topaz, and put it into your backpack.", typeof( Topaz ) ),
					new HarvestResource( 75.0, 60.0, 115.0, "You chip some jade, and put it into your backpack.", typeof( Jade ) ),
					new HarvestResource( 80.0, 70.0, 125.0, "You chip some fire emerald, and put it into your backpack.", typeof( FireEmerald ) ),
					new HarvestResource( 90.0, 80.0, 135.0, "You chip some star ruby, and put it into your backpack.", typeof( StarRuby ) ),
					new HarvestResource( 95.0, 90.0, 145.0, "You chip some diamond, and put it into your backpack.", typeof( Diamond ) ),
					new HarvestResource( 99.0, 95.0, 160.0, "You chip some blue diamond, and put it into your backpack.", typeof( BlueDiamond ) )
				};

			veins = new HarvestVein[]
				{
					new HarvestVein( 45.0, 0.0, res[0], null ), // Jewelry Rock
					new HarvestVein( 8.8, 0.5, res[1], res[0] ), // Amber
					new HarvestVein( 7.3, 0.5, res[2], res[0] ), // Emerald
					new HarvestVein( 5.1, 0.5, res[3], res[0] ), // Star Rose
					new HarvestVein( 4.8, 0.5, res[4], res[0] ), // Amethyst
					new HarvestVein( 4.6, 0.5, res[5], res[0] ), // Citrine
					new HarvestVein( 3.8, 0.5, res[6], res[0] ), // Turquoise
					new HarvestVein( 3.5, 0.5, res[7], res[0] ), // Ruby
					new HarvestVein( 3.1, 0.5, res[8], res[0] ), // Sapphire
					new HarvestVein( 2.3, 0.5, res[9], res[0] ), // Tourmaline
					new HarvestVein( 2.1, 0.5, res[10], res[0] ), // Star Sapphire
					new HarvestVein( 1.9, 0.5, res[11], res[0] ), // Topaz
					new HarvestVein( 1.6, 0.5, res[12], res[0] ), // Jade
					new HarvestVein( 1.2, 0.5, res[13], res[0] ), // Fire Emerald
					new HarvestVein( 0.9, 0.5, res[14], res[0] ), // Star Ruby
					new HarvestVein( 0.7, 0.5, res[15], res[0] ), // Diamond
					new HarvestVein( 0.6, 0.25, res[16], res[0] ) // Blue Diamond
				};

			gems.Resources = res;
			gems.Veins = veins;

			sys.Definitions.Add( gems );
			#endregion
		}

		/// <summary>
		/// Gets the Gem Mining for CrystalMining.cs
		/// </summary>
		/// <param name="sys"></param>
		/// <param name="res"></param>
		/// <param name="veins"></param>
		public static void GetGemMining( HarvestSystem sys, HarvestResource[] res, HarvestVein[] veins )
		{
			#region Mining for Gems
			HarvestDefinition mininggems = m_MiningGems = new HarvestDefinition();

			// Resource banks are every 8x8 tiles
			mininggems.BankWidth = 8;
			mininggems.BankHeight = 8;

			// Every bank holds from 10 to 34 ore
			mininggems.MinTotal = 10;
			mininggems.MaxTotal = 34;

			// A resource bank will respawn its content every 10 to 20 minutes
			mininggems.MinRespawn = TimeSpan.FromMinutes( 10.0 );
			mininggems.MaxRespawn = TimeSpan.FromMinutes( 20.0 );

			// Skill checking is done on the Mining skill
			mininggems.Skill = SkillName.Mining;

			// Set the list of harvestable tiles
			mininggems.Tiles = m_MountainAndCaveTiles;

			// Players must be within 2 tiles to harvest
			mininggems.MaxRange = 2;

			// One ore per harvest action
			mininggems.ConsumedPerHarvest = 1;
			mininggems.ConsumedPerFeluccaHarvest = 2;

			// The digging effect
			mininggems.EffectActions = new int[]{ 11 };
			mininggems.EffectSounds = new int[]{ 0x125, 0x126 };
			mininggems.EffectCounts = new int[]{ 1 };
			mininggems.EffectDelay = TimeSpan.FromSeconds( 1.6 );
			mininggems.EffectSoundDelay = TimeSpan.FromSeconds( 0.9 );

			mininggems.NoResourcesMessage = "There is no gems here to mine.";
			mininggems.DoubleHarvestMessage = "Someone has gotten to the gems before you."; 
			mininggems.TimedOutOfRangeMessage = 503041; // You have moved too far away to continue mining.
			mininggems.OutOfRangeMessage = 500446; // That is too far away.
			mininggems.FailMessage = "You loosen some rocks but fail to find any useable gems.";
			mininggems.PackFullMessage = "Your backpack is full, so the gem you mined is lost.";
			mininggems.ToolBrokeMessage = 1044038; // You have worn out your tool!

			res = new HarvestResource[]
				{
					new HarvestResource( 45.0, 20.0, 80.0, "You dig some sort of jewelry rock and put it in your backpack.", typeof( JewelRock ) ),
					new HarvestResource( 50.0, 25.0, 90.0, "You dig some onyx, and put it into your backpack.", typeof( Onyx ) ),
					new HarvestResource( 90.0, 60.0, 120.0, "You dig some jasper, and put it into your backpack.", typeof( Jasper ) )
				};

			veins = new HarvestVein[]
				{
					new HarvestVein( 80.0, 0.0, res[0], null ), // Jewelry Rock
					new HarvestVein( 18.5, 0.5, res[1], res[0] ), // Onyx
					new HarvestVein( 1.5, 0.5, res[2], res[0] ) // Jasper
				};

			mininggems.Resources = res;
			mininggems.Veins = veins;

			sys.Definitions.Add( mininggems );
			#endregion
		}

		/// <summary>
		/// Get the Bars for the CrystalMining.cs
		/// </summary>
		/// <param name="sys"></param>
		/// <param name="res"></param>
		/// <param name="veins"></param>
		public static void GetBarMining( HarvestSystem sys, HarvestResource[] res, HarvestVein[] veins )
		{
			#region Mining for Bars
			HarvestDefinition bars = m_Bars = new HarvestDefinition();

			// Resource banks are every 8x8 tiles
			bars.BankWidth = 8;
			bars.BankHeight = 8;

			// Every bank holds from 10 to 34 ore
			bars.MinTotal = 10;
			bars.MaxTotal = 34;

			// A resource bank will respawn its content every 10 to 20 minutes
			bars.MinRespawn = TimeSpan.FromMinutes( 10.0 );
			bars.MaxRespawn = TimeSpan.FromMinutes( 20.0 );

			// Skill checking is done on the Mining skill
			bars.Skill = SkillName.Mining;

			// Set the list of harvestable tiles
			bars.Tiles = m_MountainAndCaveTiles;

			// Players must be within 2 tiles to harvest
			bars.MaxRange = 2;

			// One ore per harvest action
			bars.ConsumedPerHarvest = 1;
			bars.ConsumedPerFeluccaHarvest = 2;

			// The digging effect
			bars.EffectActions = new int[]{ 11 };
			bars.EffectSounds = new int[]{ 0x125, 0x126 };
			bars.EffectCounts = new int[]{ 1 };
			bars.EffectDelay = TimeSpan.FromSeconds( 1.6 );
			bars.EffectSoundDelay = TimeSpan.FromSeconds( 0.9 );

			bars.NoResourcesMessage = "There is no metal here to mine.";
			bars.DoubleHarvestMessage = "Someone has gotten to the metal before you."; 
			bars.TimedOutOfRangeMessage = 503041; // You have moved too far away to continue mining.
			bars.OutOfRangeMessage = 500446; // That is too far away.
			bars.FailMessage = "You loosen some rocks but fail to find any useable metal.";
			bars.PackFullMessage = "Your backpack is full, so the metal you mined is lost.";
			bars.ToolBrokeMessage = 1044038; // You have worn out your tool!

			res = new HarvestResource[]
				{
					new HarvestResource( 00.0, 00.0, 95.0, "You dig some sort of jewelry rock and put it in your backpack.", typeof( JewelRock ) ),
					new HarvestResource( 55.0, 20.0, 100.0, "You dig some copper bar and put it in your backpack.", typeof( CopperBar ) ),
					new HarvestResource( 60.0, 25.0, 105.0, "You dig some silver bar and put it in your backpack.", typeof( SilverBar ) ),
					new HarvestResource( 70.0, 30.0, 110.0, "You dig some gold bar and put it in your backpack.", typeof( GoldBar ) ),
					new HarvestResource( 75.0, 35.0, 115.0, "You dig some platinum bar and put it in your backpack.", typeof( PlatinumBar ) ),
					new HarvestResource( 80.0, 40.0, 120.0, "You dig some velium bar and put it in your backpack.", typeof( VeliumBar ) ),
					new HarvestResource( 85.0, 45.0, 125.0, "You dig some arycilan bar and put it in your backpack.", typeof( ArycilanBar ) ),
					new HarvestResource( 90.0, 50.0, 130.0, "You dig some orbsydian bar and put it in your backpack.", typeof( OrbsydianBar ) ),
					new HarvestResource( 95.0, 55.0, 135.0, "You dig some xulian bar and put it in your backpack.", typeof( XulianBar ) ),
					new HarvestResource( 99.0, 60.0, 140.0, "You dig some paragon bar and put it in your backpack.", typeof( ParagonBar ) )
				};

			veins = new HarvestVein[]
				{
					new HarvestVein( 30.0, 0.0, res[0], null   ), // Jewelry Rock
					new HarvestVein( 20.0, 0.5, res[1], res[0] ), // Copper
					new HarvestVein( 15.2, 0.5, res[2], res[0] ), // Silver
					new HarvestVein( 11.6, 0.5, res[3], res[0] ), // Gold
					new HarvestVein( 7.8, 0.5, res[4], res[0] ), // Platinum
					new HarvestVein( 6.2, 0.5, res[5], res[0] ), // Velium
					new HarvestVein( 3.7, 0.5, res[6], res[0] ), // Arycilan
					new HarvestVein( 4.2, 0.5, res[7], res[0] ), // Orbsydian
					new HarvestVein( 2.3, 0.5, res[8], res[0] ), // Xulian
					new HarvestVein( 1.8, 0.5, res[9], res[0] )  // Paragon
				};

			bars.Resources = res;
			bars.Veins = veins;

			sys.Definitions.Add( bars );
			#endregion
		}

		/*****You do not have to edit anything below*****/

		#region Core Property
		/// <summary>
		/// Example of how Version works...  Major, Minor, Fixes
		/// Version, <Major>3</Major>.<Minor>0</Minor><Fixes>a</Fixes>
		/// </summary>
		private static string m_Version = "3.0d"; // The Version of the Jewel Crafting System
		#endregion
		
		#region Readonly Methods

		private static HarvestDefinition m_MiningGems, m_Bars;

		public static HarvestDefinition MiningGems
		{
			get{ return m_MiningGems; }
		}

		public static HarvestDefinition Bars
		{
			get{ return m_Bars; }
		}

		public static void Initialize()
		{
			if( JCore.Enabled )
				Console.WriteLine( " - Jewel Craft System: Version [{0}], is enabled on this Server.", JCore.Version );
		
			Array.Sort( m_CrystalTiles );
		}

		private static int[] m_MountainAndCaveTiles = new int[]
			{
				220, 221, 222, 223, 224, 225, 226, 227, 228, 229,
				230, 231, 236, 237, 238, 239, 240, 241, 242, 243,
				244, 245, 246, 247, 252, 253, 254, 255, 256, 257,
				258, 259, 260, 261, 262, 263, 268, 269, 270, 271,
				272, 273, 274, 275, 276, 277, 278, 279, 286, 287,
				288, 289, 290, 291, 292, 293, 294, 296, 296, 297,
				321, 322, 323, 324, 467, 468, 469, 470, 471, 472,
				473, 474, 476, 477, 478, 479, 480, 481, 482, 483,
				484, 485, 486, 487, 492, 493, 494, 495, 543, 544,
				545, 546, 547, 548, 549, 550, 551, 552, 553, 554,
				555, 556, 557, 558, 559, 560, 561, 562, 563, 564,
				565, 566, 567, 568, 569, 570, 571, 572, 573, 574,
				575, 576, 577, 578, 579, 581, 582, 583, 584, 585,
				586, 587, 588, 589, 590, 591, 592, 593, 594, 595,
				596, 597, 598, 599, 600, 601, 610, 611, 612, 613,

				1010, 1741, 1742, 1743, 1744, 1745, 1746, 1747, 1748, 1749,
				1750, 1751, 1752, 1753, 1754, 1755, 1756, 1757, 1771, 1772,
				1773, 1774, 1775, 1776, 1777, 1778, 1779, 1780, 1781, 1782,
				1783, 1784, 1785, 1786, 1787, 1788, 1789, 1790, 1801, 1802,
				1803, 1804, 1805, 1806, 1807, 1808, 1809, 1811, 1812, 1813,
				1814, 1815, 1816, 1817, 1818, 1819, 1820, 1821, 1822, 1823,
				1824, 1831, 1832, 1833, 1834, 1835, 1836, 1837, 1838, 1839,
				1840, 1841, 1842, 1843, 1844, 1845, 1846, 1847, 1848, 1849,
				1850, 1851, 1852, 1853, 1854, 1861, 1862, 1863, 1864, 1865,
				1866, 1867, 1868, 1869, 1870, 1871, 1872, 1873, 1874, 1875,
				1876, 1877, 1878, 1879, 1880, 1881, 1882, 1883, 1884, 1981,
				1982, 1983, 1984, 1985, 1986, 1987, 1988, 1989, 1990, 1991,
				1992, 1993, 1994, 1995, 1996, 1997, 1998, 1999, 2000, 2001,
				2002, 2003, 2004, 2028, 2029, 2030, 2031, 2032, 2033, 2100,
				2101, 2102, 2103, 2104, 2105,

				0x453B, 0x453C, 0x453D, 0x453E, 0x453F, 0x4540, 0x4541,
				0x4542, 0x4543, 0x4544,	0x4545, 0x4546, 0x4547, 0x4548,
				0x4549, 0x454A, 0x454B, 0x454C, 0x454D, 0x454E,	0x454F
			};

		private static int[] m_CrystalTiles = new int[]
			{
				0x2206, 0x2207, 0x2208, 0x2209, 0x220A, 0x220B, 0x220C,
				0x220D, 0x220E, 0x220F, 0x2210, 0x2211, 0x2212, 0x2213,
				0x2214, 0x2215, 0x2216, 0x2217, 0x2218, 0x2219, 0x221A,
				0x221B, 0x221C, 0x221D, 0x221E, 0x221F, 0x2220, 0x2221,
				0x2222, 0x2223, 0x2224, 0x2225, 0x2226, 0x2227, 0x2228,
				0x2229, 0x222A, 0x222B, 0x222C,
				
				0x223A, 0x223B, 0x223C, 0x223D, 0x223E, 0x223F, 0x2240,
				0x2241, 0x2242, 0x2243, 0x2243, 0x2244, 0x2245, 0x2246, 
				0x2247, 0x2248, 0x2249
			};

		public static string Version{ get{ return m_Version; } }

		/// <summary>
		/// Is AOS Enabled?
		/// </summary>
		public static bool AOS		
		{
			get
			{
				if( Core.AOS )
					return true;
				
				return false;
			}
		}
		
		/// <summary>
		/// Is Samurai Empire Enabled?
		/// </summary>
		public static bool SE		
		{
			get
			{
				if( Core.SE )
					return true;
				
				return false;
			}
		}
		
		public static bool SE_AOS		
		{
			get
			{
				if( Core.SE && Core.AOS )
					return true;
				
				return false;
			}
		}
		#endregion   
		
		public JCore(){}
	}
}
