/**************************************************************/
/*					  Jewel Crafting System 3
/* 
/*	Scripted by Ravenal/awakenlands
/*  Completed on:  5/31/2005
/*
/*	This script is for anyone to use and edit, please be 
/*  considerate not to claim this as your script, thanks.
/*
/*	This Script is an Edited Script for the use of JCS3.
/*	
/*	Script Site:	   http://jcs3.uniphix.com
/*	Shard's Site:	   http://www.paragonix.org
/*	Developer's Site:  http://www.orbsydia.com
/*	Emulator's Site:   http://www.runuo.com
/*
/*					  Script Version 3.0d
/**************************************************************/
using System;

namespace Server.Items
{
	public abstract class BaseBracelet : BaseJewel
	{
		public override int BaseGemTypeNumber{ get{ return 1044221; } } // star sapphire bracelet

		public BaseBracelet( int itemID ) : this( itemID, BarType.None )
		{
		}

		public BaseBracelet( int itemID, BarType type ) : base( itemID, type, Layer.Bracelet )
		{
			this.SetName( "bracelet" );
		}

		public BaseBracelet( Serial serial ) : base( serial )
		{
		}

		public override void Serialize( GenericWriter writer )
		{
			base.Serialize( writer );

			writer.Write( (int) 0 ); // version
		}

		public override void Deserialize( GenericReader reader )
		{
			base.Deserialize( reader );

			int version = reader.ReadInt();
		}
	}

	public class Bracelet : BaseBracelet
	{
		[Constructable]
		public Bracelet() : base( 0x1086, BarType.None )
		{
			Weight = 0.1;
		}

		public Bracelet( Serial serial ) : base( serial )
		{
		}

		public override void Serialize( GenericWriter writer )
		{
			base.Serialize( writer );

			writer.Write( (int) 0 ); // version
		}

		public override void Deserialize( GenericReader reader )
		{
			base.Deserialize( reader );

			int version = reader.ReadInt();
		}
	}
	
	public class ParagonBracelet : BaseBracelet
	{
		[Constructable]
		public ParagonBracelet() : base( 0x1086, BarType.None )
		{
			Weight = 0.1;
		}

		public ParagonBracelet( Serial serial ) : base( serial )
		{
		}

		public override void Serialize( GenericWriter writer )
		{
			base.Serialize( writer );

			writer.Write( (int) 0 ); // version
		}

		public override void Deserialize( GenericReader reader )
		{
			base.Deserialize( reader );

			int version = reader.ReadInt();
		}
	}
	
	public class XulianBracelet : BaseBracelet
	{
		[Constructable]
		public XulianBracelet() : base( 0x1086, BarType.Xulian )
		{
			Weight = 0.1;
		}

		public XulianBracelet( Serial serial ) : base( serial )
		{
		}

		public override void Serialize( GenericWriter writer )
		{
			base.Serialize( writer );

			writer.Write( (int) 0 ); // version
		}

		public override void Deserialize( GenericReader reader )
		{
			base.Deserialize( reader );

			int version = reader.ReadInt();
		}
	}
	
	public class OrbsydianBracelet : BaseBracelet
	{
		[Constructable]
		public OrbsydianBracelet() : base( 0x1086, BarType.Orbsydian )
		{
			Weight = 0.1;
		}

		public OrbsydianBracelet( Serial serial ) : base( serial )
		{
		}

		public override void Serialize( GenericWriter writer )
		{
			base.Serialize( writer );

			writer.Write( (int) 0 ); // version
		}

		public override void Deserialize( GenericReader reader )
		{
			base.Deserialize( reader );

			int version = reader.ReadInt();
		}
	}
	
	public class ArycilanBracelet : BaseBracelet
	{
		[Constructable]
		public ArycilanBracelet() : base( 0x1086, BarType.Arycilan )
		{
			Weight = 0.1;
		}

		public ArycilanBracelet( Serial serial ) : base( serial )
		{
		}

		public override void Serialize( GenericWriter writer )
		{
			base.Serialize( writer );

			writer.Write( (int) 0 ); // version
		}

		public override void Deserialize( GenericReader reader )
		{
			base.Deserialize( reader );

			int version = reader.ReadInt();
		}
	}
	
	public class VeliumBracelet : BaseBracelet
	{
		[Constructable]
		public VeliumBracelet() : base( 0x1086, BarType.Velium )
		{
			Weight = 0.1;
		}

		public VeliumBracelet( Serial serial ) : base( serial )
		{
		}

		public override void Serialize( GenericWriter writer )
		{
			base.Serialize( writer );

			writer.Write( (int) 0 ); // version
		}

		public override void Deserialize( GenericReader reader )
		{
			base.Deserialize( reader );

			int version = reader.ReadInt();
		}
	}
	
	public class PlatinumBracelet : BaseBracelet
	{
		[Constructable]
		public PlatinumBracelet() : base( 0x1086, BarType.Platinum )
		{
			Weight = 0.1;
		}

		public PlatinumBracelet( Serial serial ) : base( serial )
		{
		}

		public override void Serialize( GenericWriter writer )
		{
			base.Serialize( writer );

			writer.Write( (int) 0 ); // version
		}

		public override void Deserialize( GenericReader reader )
		{
			base.Deserialize( reader );

			int version = reader.ReadInt();
		}
	}

	public class GoldBracelet : BaseBracelet
	{
		[Constructable]
		public GoldBracelet() : base( 0x1086, BarType.Gold )
		{
			Weight = 0.1;
		}

		public GoldBracelet( Serial serial ) : base( serial )
		{
		}

		public override void Serialize( GenericWriter writer )
		{
			base.Serialize( writer );

			writer.Write( (int) 0 ); // version
		}

		public override void Deserialize( GenericReader reader )
		{
			base.Deserialize( reader );

			int version = reader.ReadInt();
		}
	}

	public class SilverBracelet : BaseBracelet
	{
		[Constructable]
		public SilverBracelet() : base( 0x1086, BarType.Silver )
		{
			Weight = 0.1;
		}

		public SilverBracelet( Serial serial ) : base( serial )
		{
		}

		public override void Serialize( GenericWriter writer )
		{
			base.Serialize( writer );

			writer.Write( (int) 0 ); // version
		}

		public override void Deserialize( GenericReader reader )
		{
			base.Deserialize( reader );

			int version = reader.ReadInt();
		}
	}
	
	public class CopperBracelet : BaseBracelet
	{
		[Constructable]
		public CopperBracelet() : base( 0x1086, BarType.Copper )
		{
			Weight = 0.1;
		}

		public CopperBracelet( Serial serial ) : base( serial )
		{
		}

		public override void Serialize( GenericWriter writer )
		{
			base.Serialize( writer );

			writer.Write( (int) 0 ); // version
		}

		public override void Deserialize( GenericReader reader )
		{
			base.Deserialize( reader );

			int version = reader.ReadInt();
		}
	}
}
