/**************************************************************/
/*					  Jewel Crafting System 3
/* 
/*	Scripted by Ravenal/awakenlands
/*  Completed on:  5/31/2005
/*
/*	This script is for anyone to use and edit, please be 
/*  considerate not to claim this as your script, thanks.
/*
/*	This Script is an Edited Script for the use of JCS3.
/*	
/*	Script Site:	   http://jcs3.uniphix.com
/*	Shard's Site:	   http://www.paragonix.org
/*	Developer's Site:  http://www.orbsydia.com
/*	Emulator's Site:   http://www.runuo.com
/*
/*					  Script Version 3.0
/**************************************************************/

using System;
using System.Collections;
using Server.Items;
using Server.Engines.JewelCraft;

namespace Server.Mobiles
{
	public class SBJewel: SBInfo
	{
		private ArrayList m_BuyInfo = new InternalBuyInfo();
		private IShopSellInfo m_SellInfo = new InternalSellInfo();

		public SBJewel()
		{
		}

		public override IShopSellInfo SellInfo { get { return m_SellInfo; } }
		public override ArrayList BuyInfo { get { return m_BuyInfo; } }

		public class InternalBuyInfo : ArrayList
		{
			public InternalBuyInfo()
			{
				Add( new GenericBuyInfo( "1060740", typeof( BroadcastCrystal ),  68, 20, 0x1ED0, 0, new object[] {  500 } ) ); // 500 charges
				Add( new GenericBuyInfo( "1060740", typeof( BroadcastCrystal ), 131, 20, 0x1ED0, 0, new object[] { 1000 } ) ); // 1000 charges
				Add( new GenericBuyInfo( "1060740", typeof( BroadcastCrystal ), 256, 20, 0x1ED0, 0, new object[] { 2000 } ) ); // 2000 charges

				Add( new GenericBuyInfo( "1060740", typeof( ReceiverCrystal ), 6, 20, 0x1ED0, 0 ) );

				Add( new GenericBuyInfo( typeof( Amber ), 50, 20, 0xF25, 0 ) );
				Add( new GenericBuyInfo( typeof( Amethyst ), 84, 20, 0xF16, 0 ) );
				Add( new GenericBuyInfo( typeof( Citrine ), 88, 20, 0xF15, 0 ) );
				
				if( JCore.SellRares )
					Add( new GenericBuyInfo( typeof( Diamond ), 320, 20, 0xF26, 0 ) );
				else if( !JCore.Enabled )
					Add( new GenericBuyInfo( typeof( Diamond ), 320, 20, 0xF26, 0 ) );

				Add( new GenericBuyInfo( typeof( Emerald ), 64, 20, 0xF10, 0 ) );
				Add( new GenericBuyInfo( typeof( Ruby ), 90, 20, 0xF13, 0 ) );
				Add( new GenericBuyInfo( typeof( Sapphire ), 104, 20, 0xF19, 0 ) );
				Add( new GenericBuyInfo( typeof( StarSapphire ), 112, 20, 0xF21, 0 ) );
				Add( new GenericBuyInfo( typeof( Tourmaline ), 106, 20, 0xF2D, 0 ) );
				
				if( JCore.Enabled )
				{
					Add( new GenericBuyInfo( "an onyx", typeof( Onyx ), 100, 20, 0xF12, JCore.OnyxHue ) );
					Add( new GenericBuyInfo( "a star rose", typeof( StarRose ), 66, 20, 0xF2B, JCore.StarRoseHue ) );
					Add( new GenericBuyInfo( "a turquoise", typeof( Turquoise ), 96, 20, 0xF1B, JCore.TurquoiseHue ) );
					Add( new GenericBuyInfo( "an opal", typeof( Opal ), 84, 20, 0xF24, JCore.OpalHue ) );
				}
		
				if( JCore.SellRares )
				{
					Add( new GenericBuyInfo( "a pearl", typeof( Pearl ), 196, 20, 0xF13, JCore.PearlHue ) );
					Add( new GenericBuyInfo( "a jade", typeof( Jade ), 152, 20, 0xF2F, JCore.JadeHue ) );
					Add( new GenericBuyInfo( "a jasper", typeof( Jasper ), 136, 20, 0xF25, JCore.JasperHue ) );
					Add( new GenericBuyInfo( "a blue diamond", typeof( BlueDiamond ), 370, 20, 0xF29, JCore.BlueDiamondHue ) );
					Add( new GenericBuyInfo( "a fire emerald", typeof( FireEmerald ), 208, 20, 0xF10, JCore.FireEmeraldHue ) );
					Add( new GenericBuyInfo( "a fire opal", typeof( FireOpal ), 144, 20, 0xF23, JCore.FireOpalHue ) );
					Add( new GenericBuyInfo( "a star ruby", typeof( StarRuby ), 240, 20, 0xF2A, JCore.StarRubyHue ) );
					Add( new GenericBuyInfo( "a topaz", typeof( Topaz ), 106, 20, 0xF19, JCore.TopazHue ) );
				}				

				if( JCore.SellJewelRock )
					Add( new GenericBuyInfo( "a jewelry rock", typeof( JewelRock ), 8, 20, 0x136C, 1285 ) );

				if( JCore.Enabled )
				{
					Add( new GenericBuyInfo( "a copper bar", typeof( CopperBar ), 20, 80, 0x1be3, JCore.CopperBarHue ) );
					Add( new GenericBuyInfo( "a silver bar", typeof( SilverBar ), 50, 80, 0x1bf5, JCore.SilverBarHue ) );
					Add( new GenericBuyInfo( "a gold bar", typeof( GoldBar ), 125, 80, 0x1be9, JCore.GoldBarHue ) );
					Add( new GenericBuyInfo( "a platinum bar", typeof( PlatinumBar ), 250, 80, 0x1bf5, JCore.PlatinumBarHue ) );
				}

				if( JCore.SellRares )
				{
					Add( new GenericBuyInfo( "a velium bar", typeof( VeliumBar ), 450, 80, 0x1bf5, JCore.VeliumBarHue ) );
					Add( new GenericBuyInfo( "an arycilan bar", typeof( ArycilanBar ), 600, 80, 0x1bf5, JCore.ArycilanBarHue ) );
					Add( new GenericBuyInfo( "an orbsydian bar", typeof( OrbsydianBar ), 850, 80, 0x1bf5, JCore.OrbsydianBarHue ) );
					Add( new GenericBuyInfo( "a xulian bar", typeof( XulianBar ), 1280, 80, 0x1bf5, JCore.XulianBarHue ) );
					Add( new GenericBuyInfo( "a paragon bar", typeof( ParagonBar ), 1460, 80, 0x1bf5, JCore.ParagonBarHue ) );
				}
			
				if( JCore.Enabled )
				{
					Add( new GenericBuyInfo( "a jewelry kit", typeof( JewelryKit ), 25, 20, 0x1EB8, 16 ) );
					Add( new GenericBuyInfo( "a jewelry shovel", typeof( JewelryShovel ), 15, 20, 0xF39, 16 ) );
				}

				if( JCore.SellJewelryChisel )
					Add( new GenericBuyInfo( "a jewelry chisel", typeof( JewelryChisel ), 15, 20, 0x12B3, 16 ) );

				if( JCore.SellEnchantedScroll )
					Add( new GenericBuyInfo( "an enchanted scroll", typeof( EnchantedScroll ), 2500, 80, 0x1F6D, 16 ) );
			}
		}

		public class InternalSellInfo : GenericSellInfo
		{
			public InternalSellInfo()
			{
				Add( typeof( JewelRock ), 4 );
				Add( typeof( CopperBar ), 10 );
				Add( typeof( SilverBar ), 25 );
				Add( typeof( GoldBar ), 75 );
				Add( typeof( PlatinumBar ), 125 );
				Add( typeof( VeliumBar ), 225 );
				Add( typeof( ArycilanBar ), 300 );
				Add( typeof( OrbsydianBar ), 425 );
				Add( typeof( XulianBar ), 640 );
				Add( typeof( ParagonBar ), 730 );

				Add( typeof( Amber ), 25 );
				Add( typeof( Amethyst ), 42 );
				Add( typeof( Citrine ), 44 );
				Add( typeof( Diamond ), 160 );
				Add( typeof( Emerald ), 32 );
				Add( typeof( Ruby ), 45 );
				Add( typeof( Sapphire ), 52 );
				Add( typeof( StarSapphire ), 56 );
				Add( typeof( Tourmaline ), 53 );
				Add( typeof( StarRuby ), 120 );
				Add( typeof( Onyx ), 50 );
				Add( typeof( FireEmerald ), 104 );
				Add( typeof( Jade ), 76 );
				Add( typeof( Jasper ), 68 );
				Add( typeof( FireOpal ), 72 );
				Add( typeof( Pearl ), 98 );
				Add( typeof( Opal ), 42 );
				Add( typeof( Topaz ), 53 );
				Add( typeof( Turquoise ), 48 );
				Add( typeof( StarRose ), 33 );
				Add( typeof( BlueDiamond ), 185 );

				//TODO: When EnchanterQuest is Built, this will be removed.
				Add( typeof( EnchantedScroll ), 500 );
			}
		}
	}
}
